----------------------------------------------------------------------------
-----  AddOn:			ReadySetDing								--------		----> Insert some Warcraft 3 [Steam Tank] ASCII Art here ! <----
-----  Author:			Ketho (EU-Boulderfist Alliance CHN)			--------		   http://classic.battle.net/war3/human/units/siegeengine.shtml
-----  Creation Date:	2010.01.04 (4 January 2010)					--------
-----  Text Editor:		Notepad++									--------	http://notepad-plus.sourceforge.net/
------ # Version -----------------------------------------------------------	http://www.wowinterface.com/downloads/info16220-ReadySetDing.html
-----  ReadySetDing								 v0.61 [2010.10.14]	--------	http://wow.curse.com/downloads/wow-addons/details/readysetding.aspx
-----  Ace3 Development Framework				  r971 [2010.10.12]	--------	http://wow.curse.com/downloads/wow-addons/details/ace3.aspx
------ # Features ----------------------------------------------------------
-----  01  Announce Time Taken for Ding								--------
-----  02  Compare Leveling Speed*									--------
------- # Index ------------------------------------------------------------
-----  01  OPTIONS AND DEFAULT VARIABLES							--------	Line   34
-----  02  OnInitialize, OnEnable, OnDisable						--------	Line  519
-----  03  FUNCTION HANDLERS										--------	Line  673
-----  04  EVENT HANDLERS											--------	Line  853
----------------------------------------------------------------------------

ReadySetDing = LibStub("AceAddon-3.0"):NewAddon("ReadySetDing", "AceConsole-3.0", "AceEvent-3.0", "AceTimer-3.0") -- Instance of AceAddon Class; http://www.wowace.com/addons/ace3/pages/api/ace-addon-3-0/
local L = LibStub("AceLocale-3.0"):GetLocale("ReadySetDing", true) -- http://www.wowace.com/addons/ace3/pages/api/ace-locale-3-0/

--	Upvalues / Abbreviations / File-local Scope Variables
local _G = _G -- make global table upvalue
local iconCropped = "0:0:64:64:4:60:4:60" -- Texture Cropped(-4 px -> 56x56 px) -- http://www.wowwiki.com/UI_escape_sequences
local SCM = SendChatMessage
local throttle_randomIcon1 = 0; local throttle_playSound = 0; local throttle_realZone = 0; local throttle_autoGratzP = 0; local throttle_autoGratzG = 0; -- throttle, manage/limit flow
local lastRequestedPlayedTime = GetTime(); local currentLevelTimeSnapshot; local totalLevelTimeSnapshot; local levelTime; local levelTime2; local timeInstance = 0; local timeInstance2 = 0; -- time variables
local TPM_currentLevelTime = 0; local TPM_currentLevelTime2; local TPM_totalTime = 0; local TPM_totalTime2 = 0; local PLU_level -- event variables
local randomIcon1; -- random variables
local playerName; local playerLevel; local playerDinged; local expansionLevel; local maxLevel = 80 -- player variables
local soundPath; local realZone; local gratzName; -- rest vars

	-----------------------------------------------
	-----  01  OPTIONS AND DEFAULT VARIABLES  -----
	-----------------------------------------------
--- Blizzard GUI Options --- http://www.wowace.com/addons/ace3/pages/ace-config-3-0-options-tables/
local optionsMain = {
    type = 'group',
	name = "\124cffADFF2FReadySet\124r|cffFFFFFFDing|r |cffB6CA00v0.61|r                               |cffFFFFFF2010.10.14|r", -- Main Options Header
	handler = ReadySetDing,
	args = {
		toggleEnableAddOn = {
			type = "toggle",
			order = 1,
			descStyle = "no tooltip plz",
			name = "|TInterface\\AddOns\\ReadySetDing\\Images\\Windows7:30:30:-6:0|t|cff71D5FF"..L["Enable AddOn"].."|r", -- TestLocale Method 2: Without the UI Escape Sequence Coloring
			get = function(info) return ReadySetDing.db.profile.enableAddOn end,
			set = function(info, value) ReadySetDing.db.profile.enableAddOn = value
				if ReadySetDing.db.profile.enableAddOn == true then ReadySetDing:Enable() -- Turn AddOn on
				elseif ReadySetDing.db.profile.enableAddOn == false then ReadySetDing:Disable() -- Turn AddOn off
				end
			end,
		},
		toggleScreenshot = {
			type = "toggle",
			order = 3,
			descStyle = "no tooltip plz",
			name = "|TInterface\\Icons\\inv_misc_spyglass_03:22:22:"..iconCropped.."|t "..L["Take Screenshot"],
			get = function(info) return ReadySetDing.db.profile.Screenshot end,
			set = function(info, value) ReadySetDing.db.profile.Screenshot = value end,
			disabled = "OptionsDisabled",
		},
		toggleAutoGratz = {
			type = "toggle",
			order = 5,
			desc = "Please dont alt+tab with Auto Gratz enabled, it will |cff71D5FFspam for all \"queued\" dings|r when alt+tabbing back",
			name = "|TInterface\\Icons\\INV_Misc_CelebrationCake_01:22:22:"..iconCropped.."|t Auto Gratz",
			get = function(info) return ReadySetDing.db.profile.AutoGratz end,
			set = function(info, value) ReadySetDing.db.profile.AutoGratz = value end,
			disabled = "OptionsDisabled",
		},
		toggleBNetBroadcast = {
			type = "toggle",
			order = 2,
			desc = "The previous message will be restored/broadcasted|cff71D5FF again|r!",
			name = function() if GetTime() > throttle_randomIcon1 then throttle_randomIcon1 = GetTime() + 300; local a = math.random(1, 4)
				if	   a <= 2 then randomIcon1 = "PlusManz-BattleNet" -- 64px original size; ...\Data\enGB\patch-enGB-3.MPQ\Interface\FriendsFrame\PlusManz-BattleNet.blp
				elseif a == 3 then randomIcon1 = "Battlenet-WoWicon" -- 32px original size
				elseif a == 4 then randomIcon1 = "Battlenet-Sc2icon"
			end; end; return "|TInterface\\FriendsFrame\\"..randomIcon1..":24|t "..L["Broadcast to |cff71D5FFReal ID|r"]; end,
			get = function(info) return ReadySetDing.db.profile.BNetBroadcast end,
			set = function(info, value) ReadySetDing.db.profile.BNetBroadcast = value end,
			disabled = "OptionsDisabled",
		},
		toggleNormalAnnounce = {
			type = "toggle",
			order = 4,
			descStyle = "no tooltip plz",
			name = L["Announce to Say / |cffA8A8FFParty|r"],
			get = function(info) return ReadySetDing.db.profile.normalAnnounce end,
			set = function(info, value) ReadySetDing.db.profile.normalAnnounce = value end,
			disabled = "OptionsDisabled",
		},
		toggleGuildAnnounce = {
			type = "toggle",
			order = 6,
			descStyle = "no tooltip plz",
			name = L["Announce to |cff40FF40Guild|r"],
			get = function(info) return ReadySetDing.db.profile.guildAnnounce end,
			set = function(info, value) ReadySetDing.db.profile.guildAnnounce = value end,
			disabled = function()
				if ReadySetDing.db.profile.enableAddOn == false or IsInGuild() ~= 1 then return true
				else return false
				end
			end,
		},
		inputDingMessage = {
			type = "input",
			order = 7,
			width = "full",
			name = " ", -- If it was like "" then "usage" wouldnt appear
			usage = "\n|cffF6ADC6[LEVEL-]|r |cffFFFFFF= Previous level|r\n|cffADFF2F[LEVEL]|r |cffFFFFFF= "..L["New level"].."|r\n|cffF6ADC6[LEVEL#]|r |cffFFFFFF= Remaining Levels|r\n|cffF6ADC6[LEVEL+]|r |cffFFFFFF= Max Level|r\n|cff71D5FF[TIME]|r |cffFFFFFF= "..L["Level Time"].."|r\n|cff71D5FF[TOTAL]|r |cffFFFFFF= "..L["Total Time"].."|r\n|cff71D5FF[DIFF]|r |cffFFFFFF= Level Time Difference|r\n|cffB6CA00[SPEED]|r |cffFFFFFF= Last 5 LevelSpeed|r\n|cffB6CA00[SPEED+]|r |cffFFFFFF= Average LevelSpeed|r\n|cffFF6347[DEATHS]|r |cffFFFFFF= Level Deaths|r\n|cffFF6347[DEATHS+]|r |cffFFFFFF= Total Deaths|r\n|cffADFF2F[NAME]|r |cffFFFFFF= Your Name|r\n|cff40FF40[GUILD]|r |cffFFFFFF= Guild Name|r\n|cff58ACFA[ZONE]|r |cffFFFFFF= Your Location|r\nRaid Targets Icons: e.g. |cffFFFFFF{skull} |TInterface\\TargetingFrame\\UI-RaidTargetingIcon_8:12|t|r\n\n|cffFFFFFFMake sure to press|r |cff71D5FF[Enter]|r / |cff71D5FF[Okay]|r",
			get = function(info) return ReadySetDing.db.profile.dingMessage end,
			set = function(info, value) ReadySetDing.db.profile.dingMessage = value
				if string.trim(ReadySetDing.db.profile.dingMessage) == "" then ReadySetDing.db.profile.dingMessage = ReadySetDing.db.defaults.profile.dingMessage; end; end,
			disabled = "OptionsDisabled",
		},
		descriptionExample = {
			type = "description",
			order = 8,
			name = function() return "|cffB6CA00Example:|r  "..RSD_ReplaceText(ReadySetDing.db.profile.dingMessage, "exampleDingMsg"); end,
		},
		header = {
			type = "header",
			order = 9,
			name = "",
		},
		descriptionDingTimes = {
			type = "description",
			order = 10,
			name = function()
				if not ReadySetDing.db.char.levelHistoryStrJoin then ReadySetDing.db.char.levelHistoryStrJoin = "Level Summary: |cffF6ADC6["..L["No Level Times Found"].."]|r"; end
				if not ReadySetDing.db.char.levelHistory then ReadySetDing.db.char.levelHistory = {}; end -- Define array
				if not ReadySetDing.db.char.levelTimeList then ReadySetDing.db.char.levelTimeList = {}; end -- new starup error
				for i = 2, 80 do
					if ReadySetDing.db.char.levelTimeList[i] then
						for j = 1, 20 do
							if not ReadySetDing.db.char.levelHistory[j] then ReadySetDing.db.char.levelHistory[j] = ""; end -- string.join() cant take nil values ..
							if ReadySetDing.db.char.levelCounterA == j then ReadySetDing.db.char.levelHistory[j] = "  "..L["Level"].." |cffF6ADC6"..(i-1).."|r - |cff71D5FF"..i.."|r:  |cffB6CA00"..RSD_TimetoString(ReadySetDing.db.char.levelTimeList[i]).."|r        "..L["Total"]..":  |cff71D5FF"..RSD_TimetoString(ReadySetDing.db.char.totalTimeList[i]).."|r"
							end
						end
						ReadySetDing.db.char.levelHistoryStrJoin = string.join("\n", -- 1 long string with linebreaks( \n ) as delimiter
							ReadySetDing.db.char.levelHistory[1], ReadySetDing.db.char.levelHistory[2], ReadySetDing.db.char.levelHistory[3], ReadySetDing.db.char.levelHistory[4], ReadySetDing.db.char.levelHistory[5],
							ReadySetDing.db.char.levelHistory[6], ReadySetDing.db.char.levelHistory[7], ReadySetDing.db.char.levelHistory[8], ReadySetDing.db.char.levelHistory[9], ReadySetDing.db.char.levelHistory[10],
							ReadySetDing.db.char.levelHistory[11], ReadySetDing.db.char.levelHistory[12], ReadySetDing.db.char.levelHistory[13], ReadySetDing.db.char.levelHistory[14], ReadySetDing.db.char.levelHistory[15],
							ReadySetDing.db.char.levelHistory[16], ReadySetDing.db.char.levelHistory[17], ReadySetDing.db.char.levelHistory[18], ReadySetDing.db.char.levelHistory[19], ReadySetDing.db.char.levelHistory[20])
					end
				end
			return ReadySetDing.db.char.levelHistoryStrJoin
			end,
		},
	},
}

local optionsAdvanced = {
	type = "group",
	name = "",
	handler = ReadySetDing,
	args = {
		toggleGratzAllAchievements = {
			type = "toggle",
			order = 1,
			width = "full",
			desc = "Congratulates for any |cff40FF40Guild|r |cffFFFF00Achievement|r, instead of just Level |cffFFFF00Achievements|r",
			name = "|TInterface\\Icons\\Achievement_Reputation_06:22:22:"..iconCropped.."|t AutoGratz All |cffFFFF00Achievements|r",
			get = function(info) return ReadySetDing.db.profile.gratzAllAchievements end,
			set = function(info, value) ReadySetDing.db.profile.gratzAllAchievements = value end,
			disabled = "OptionsDisabled",
		},
		toggleSkipLevelAchievement = {
			type = "toggle",
			order = 2,
			width = "full",
			desc = "Skips announce for|cffB6CA00 Level 10 / 20 / 30 / 40 / 50 / 60 / 70 / 80 / 85|r",
			name = "|TInterface\\Icons\\Achievement_Level_20:22:22:"..iconCropped.."|t Skip Level |cffFFFF00Achievements|r",
			get = function(info) return ReadySetDing.db.profile.skipLevelAchievement end,
			set = function(info, value) ReadySetDing.db.profile.skipLevelAchievement = value end,
			disabled = "OptionsDisabled",
		},
		toggleDebug = {
 			type = "toggle",
			order = 3,
			width = "full",
			desc = "Gives some spammy feedback\nPlease use |cff71D5FFSwatter|r from |cff71D5FFAuctioneer|r for sending error logs",
			name = "|TInterface\\Icons\\INV_Misc_QuestionMark:22:22:"..iconCropped.."|t |cff71D5FF"..L["Debug Mode"].."|r",
			get = function(info) return ReadySetDing.db.profile.Debug end,
			set = function(info, value) ReadySetDing.db.profile.Debug = value end,
			disabled = "OptionsDisabled",
		},
		header01 = {
			type = "header",
			order = 9,
			name = "",
		},
		rangeScreenshotDelay = {
			type = "range",
			order = 10,
			desc = "|cff71D5FFsoftMax|r = 2 seconds (|cffB6CA00Slider Input|r)\n|cff71D5FFmax|r = 60 seconds (|cffB6CA00Manual Input|r)\n|cffF6ADC6Default|r = 1 second",
			name = "|TInterface\\Icons\\inv_misc_spyglass_03:18:18:"..iconCropped.."|t "..L["|cffFFFFFFScreenshot|r Delay"],
			get = function(info) return ReadySetDing.db.profile.screenshotDelay end,
			set = function(info, value) ReadySetDing.db.profile.screenshotDelay = value end,
			min = 0, softMin = 0,
			max = 60, softMax = 2,
			disabled = function() if ReadySetDing.db.profile.enableAddOn == false or ReadySetDing.db.profile.Screenshot == false then return true; else return false; end; end,
		},
		rangeAutoGratzCooldown = {
			type = "range",
			order = 11,
			desc = "|cff71D5FFsoftMax|r = 120 seconds (|cffB6CA00Slider Input|r)\n|cff71D5FFmax|r = 600 seconds (|cffB6CA00Manual Input|r)\n|cffF6ADC6Default|r = 60 seconds",
			name = "|TInterface\\Icons\\INV_Misc_Food_147_Cake:18:18:"..iconCropped.."|t |cffFFFFFFAutoGratz|r Cooldown",
			get = function(info) return ReadySetDing.db.profile.autoGratzCooldown end,
			set = function(info, value) ReadySetDing.db.profile.autoGratzCooldown = value end,
			min = 0, softMin = 0,
			max = 600, softMax = 120,
			disabled = function() if ReadySetDing.db.profile.enableAddOn == false or ReadySetDing.db.profile.AutoGratz == false then return true; else return false; end; end,
		},
		rangeAutoGratzDelay = {
			type = "range",
			order = 12,
			desc = "0 seconds = |cffF6ADC6Random|r (|cffB6CA002-10 sec|r)\n|cff71D5FFsoftMax|r = 10 seconds (|cffB6CA00Slider Input|r)\n|cff71D5FFmax|r = 60 seconds (|cffB6CA00Manual Input|r)\n|cffF6ADC6Default|r = 0 (Random) (|cffB6CA002-10 sec|r)",
			name = "|TInterface\\Icons\\INV_Misc_CelebrationCake_01:18:18:"..iconCropped.."|t |cffFFFFFFAutoGratz|r Delay",
			get = function(info) return ReadySetDing.db.profile.autoGratzDelay end,
			set = function(info, value) ReadySetDing.db.profile.autoGratzDelay = value end,
			min = 0, softMin = 0,
			max = 60, softMax = 10,
			disabled = function() if ReadySetDing.db.profile.enableAddOn == false or ReadySetDing.db.profile.AutoGratz == false then return true; else return false; end; end,
		},
		rangeAutoGratzLimitLength = {
			type = "range",
			order = 13,
			desc = "This will ignore any message bigger than |cffADFF2Fvariable|r length\n\n|cff71D5FFsoftMax|r = 20 characters (|cffB6CA00Slider Input|r)\n|cff71D5FFmax|r = 255 characters (|cffB6CA00Manual Input|r)\n|cffF6ADC6Default|r = 10 characters",
			name = "|TInterface\\Icons\\INV_Misc_Food_145_Cake:18:18:"..iconCropped.."|t |cffFFFFFFAutoGratz|r Length Limit",
			get = function(info) return ReadySetDing.db.profile.autoGratzLengthLimit end,
			set = function(info, value) ReadySetDing.db.profile.autoGratzLengthLimit = value end,
			min = 0, softMin = 0,
			max = 255, softMax = 20,
			disabled = function() if ReadySetDing.db.profile.enableAddOn == false or ReadySetDing.db.profile.AutoGratz == false then return true; else return false; end; end,
		},
		header02 = {
			type = "header",
			order = 14,
			name = "",
		},
		inputAutoGratzMsg1 = {
			type = "input",
			order = 15,
			width = "full",
			name = "    |TInterface\\Icons\\INV_Misc_CelebrationCake_01:18:18:"..iconCropped.."|t |cffFFFFFFAuto Gratz|r Message",
			usage = "\n|cff58ACFA[NAME]|r = Player who said \"Ding\"\nMake sure to press|cffF6ADC6 [Enter]|r |cffFFFFFF/|r|cffF6ADC6 [Okay]|r",
			get = function(info) return ReadySetDing.db.profile.autoGratzMsg1 end,
			set = function(info, value) ReadySetDing.db.profile.autoGratzMsg1 = value
				if string.trim(ReadySetDing.db.profile.autoGratzMsg1) == "" then ReadySetDing.db.profile.autoGratzMsg1 = ReadySetDing.db.defaults.profile.autoGratzMsg1; end; end,
			disabled = "OptionsDisabled",
		},
		inputAutoGratzMsg2 = {
			type = "input",
			order = 16,
			width = "full",
			descStyle = "no tooltip plz",
			name = "",
			get = function(info) return ReadySetDing.db.profile.autoGratzMsg2 end,
			set = function(info, value) ReadySetDing.db.profile.autoGratzMsg2 = value
				if string.trim(ReadySetDing.db.profile.autoGratzMsg2) == "" then ReadySetDing.db.profile.autoGratzMsg2 = ReadySetDing.db.defaults.profile.autoGratzMsg2; end; end,
			disabled = "OptionsDisabled",
		},
		inputAutoGratzMsg3 = {
			type = "input",
			order = 17,
			width = "full",
			descStyle = "no tooltip plz",
			name = "",
			get = function(info) return ReadySetDing.db.profile.autoGratzMsg3 end,
			set = function(info, value) ReadySetDing.db.profile.autoGratzMsg3 = value
				if string.trim(ReadySetDing.db.profile.autoGratzMsg3) == "" then ReadySetDing.db.profile.autoGratzMsg3 = ReadySetDing.db.defaults.profile.autoGratzMsg3; end; end,
			disabled = "OptionsDisabled",
		},
		inputAutoGratzMsg4 = {
			type = "input",
			order = 18,
			width = "full",
			descStyle = "no tooltip plz",
			name = "",
			get = function(info) return ReadySetDing.db.profile.autoGratzMsg4 end,
			set = function(info, value) ReadySetDing.db.profile.autoGratzMsg4 = value
				if string.trim(ReadySetDing.db.profile.autoGratzMsg4) == "" then ReadySetDing.db.profile.autoGratzMsg4 = ReadySetDing.db.defaults.profile.autoGratzMsg4; end; end,
			disabled = "OptionsDisabled",
		},
		inputAutoGratzMsg5 = {
			type = "input",
			order = 19,
			width = "full",
			descStyle = "no tooltip plz",
			name = "",
			get = function(info) return ReadySetDing.db.profile.autoGratzMsg5 end,
			set = function(info, value) ReadySetDing.db.profile.autoGratzMsg5 = value
				if string.trim(ReadySetDing.db.profile.autoGratzMsg5) == "" then ReadySetDing.db.profile.autoGratzMsg5 = ReadySetDing.db.defaults.profile.autoGratzMsg5; end; end,
			disabled = "OptionsDisabled",
		},
		descriptionExample = {
			type = "description",
			order = 20,
			name = function() return "|cffB6CA00Example #1:|r  "..RSD_ReplaceText(ReadySetDing.db.profile.autoGratzMsg1, "ExampleAutoGratzMsg"); end,
		},
	},
}

local optionsTimer = {
	type = "group",
	name = "",
	handler = ReadySetDing,
	args = {
		description1 = {
			type = "description",
			order = 1,
			name = "\n",
		},
		toggleTimer = {
			type = "toggle",
			order = 2,
			descStyle = "no tooltip plz",
			width = "full",
			name = "|TInterface\\Icons\\Spell_Holy_BorrowedTime:18:18:"..iconCropped.."|t Enable |cff71D5FFInstance Timer|r",
			get = function(info) return ReadySetDing.db.profile.Timer end,
			set = function(info, value) ReadySetDing.db.profile.Timer = value end,
			disabled = "OptionsDisabled",
		},
		description2 = {
			type = "description",
			order = 3,
			name = "\n",
		},
		executePrintTimer = {
			type = "execute",
			order = 4,
			descStyle = "no tooltip plz",
			name = "Show |cffFFFFFFInstance Times|r",
			func = function()
				if ReadySetDing.db.char.timeInstanceList then -- code by Xinhuan from Wowace.com -- http://forums.wowace.com/showthread.php?p=306562#post306562
					local t2 = {}; local i = 1
					for k, v in pairs(ReadySetDing.db.char.timeInstanceList) do
						t2[i] = k -- Take all the keys of t1[] and put them in t2 as values
						i = i + 1
					end
					table.sort(t2)
					for i = 1, #t2 do -- Now print out key = value in sorted order
						print("["..t2[i].."] = "..ReadySetDing.db.char.timeInstanceList[t2[i]])
					end
				else print("|cffADFF2FReadySet|rDing: |cffF6ADC6[No Instance Times Found]|r")
				end
			end,
			disabled = "OptionsDisabled",
			},
		executeResetTimer = {
			type = "execute",
			order = 5,
			descStyle = "no tooltip plz",
			confirm = true,
			confirmText = "|TInterface\\Icons\\INV_Misc_QuestionMark:16:16:"..iconCropped.."|t Reset |cff71D5FFInstance Timer|r?\nPlease use if you quitted an instance without completing it",
			name = "Reset |cffFFFFFFInstance Timer|r",
			func = function() timeInstance = 0; end,
			disabled = "OptionsDisabled",
		},
		description3 = {
			type = "description",
			order = 6,
			name = "\n\n  Yes this tab is kinda empty for now ...",
		},
--[[ -- planning Instance Times summary for v0.70
		descriptionTimer = {
			type = "description",
			order = 4,
			name = function() if timeInstance > 0 then return "|cffB6CA00Example:|r  [Instance] cleared in "..RSD_TimetoString(GetTime() - timeInstance) else return "|cffB6CA00Example:|r |cffF6ADC6[No Instance Time Data Found]|r" end; end,
		},
--]]
	},
}

local optionsAbout = {
	type = "group",
	name = "",
	handler = ReadySetDing,
	args = {
		header01 = {
			type = "header",
			order = 1,
			name = "|cffADFF2FReadySet|r|cffFFFFFFDing|r by |cffFFFFFFKetho|r @ |cffB6CA00EU-Boulderfist|r",
		},
		descriptionAddOn = {
			type = "description",
			order = 2, -- the UI escape sequence gets broken off a lot down here ...
			name = "|cff87CEFAhttp://wow.|r|cffADFF2Fcurse|r|cff87CEFA.com/downloads/wow-addons/details/readysetding.aspx\nhttp://www.|r|cffADFF2Fwowinterface|r|cff87CEFA.com/downloads/info16220-ReadySetDing.html|r\nOfficial Thread: |cff87CEFAhttp://forums.|cffADFF2Fwowace|r|cff87CEFA.com/showthread.php?t=18511|r",
		},
		descriptionCommands = {
			type = "description",
			order = 3,
			name = "Commands:  /rsd, /readysetding",
		},
		descriptionToDo = {
			type = "description",
			order = 4,
			name = "\n|cffB6CA00v0.61|r: Lots of Bugfixes (great feedback by |cffADFF2FEincrou|r@WoWInterface);\nCode refactoring; Added even more DingMessage Variables\n\n|cffB6CA00To Do|r |cff71D5FFv0.70|r: Guild Member's Levels",
		},
		header02 = {
			type = "header",
			order = 5,
			name = "",
		},
		descriptionLevelSpeedAverage = {
			type = "description",
			order = 6,
			name = function() if playerLevel > 1 then return "Average LevelSpeed = |cff71D5FF"..RSD_TimetoString((TPM_totalTime+RSD_addedTime())/(playerLevel-1)).."|r per Level  (|cffB6CA00"..string.format("%.2f",((TPM_totalTime+RSD_addedTime())/3600)/(playerLevel-1)).."|r hour/level)" else return "Average LevelSpeed = |cffF6ADC6[No Levelspeed Data]|r" end; end,
		},
		descriptionLevelSpeedRecent = {
			type = "description",
			order = 7,
			name = function() if ReadySetDing.db.char.totalTimeList[playerLevel] and ReadySetDing.db.char.totalTimeList[playerLevel-5] then return "Last 5 LevelSpeed = |cffB6CA00"..RSD_TimetoString(((ReadySetDing.db.char.totalTimeList[playerLevel]+RSD_addedTime())-ReadySetDing.db.char.totalTimeList[playerLevel-5])/5).."|r per Level  (|cffF6ADC6"..string.format("%.2f",((ReadySetDing.db.char.totalTimeList[playerLevel]+RSD_addedTime())-ReadySetDing.db.char.totalTimeList[playerLevel-5])/18000).."|r hour/level)"
				else return "Last 5 LevelSpeed = |cffF6ADC6[No Levelspeed Data]|r" end; end,
		},
		descriptionLevelDifference = {
			type = "description",
			order = 8,
			name = function() return "Time Difference = |cff71D5FF"..RSD_timeDiff("exampleMsg").."|r than last Level" end,
		},
		descriptionDeaths = {
			type = "description",
			order = 13,
			name = function() return "Level Deaths = |cffFF6347"..ReadySetDing.db.char.deathCount.."|r, Total Deaths = |cffFF6347"..ReadySetDing.db.char.deathCountTotal.."|r" end,
		},
		header03 = {
			type = "header",
			order = 14,
			name = "",
		},
		executePrintTimes = {
			type = "execute",
			order = 15,
			name = "|TInterface\\Icons\\INV_Misc_Note_01:18:18:"..iconCropped.."|t "..L["Show |cffFFFFFFLevel Times|r"],
			func = function() -- http://www.wowwiki.com/API_getn
				if not ReadySetDing.db.char.levelTimeList or #ReadySetDing.db.char.levelTimeList == 0 then print("|cffADFF2FReadySet|rDing: |cffF6ADC6["..L["No Level Times Found"].."]|r")
				end
				for i = 2, maxLevel do
					if ReadySetDing.db.char.levelTimeList[i] then print("|cffADFF2FReadySet|rDing: "..L["Level"].." |cffF6ADC6"..(i-1).."|r - |cff71D5FF"..i.."|r: |cffB6CA00"..RSD_TimetoString(ReadySetDing.db.char.levelTimeList[i]).."|r   "..L["Total"]..": |cff71D5FF"..RSD_TimetoString(ReadySetDing.db.char.totalTimeList[i]).."|r")
					end
				end
			end,
			disabled = "OptionsDisabled",
		},
		executePlaySound = {
			type = "execute",
			order = 16,
			name = "|TSPELLS\\HOLIDAYS\\Heart:18|t Play|cffADFF2F *|r|cffF6ADC6Sound|r|cffADFF2F*|r", -- ...\Data\common.MPQ\SPELLS\HOLIDAYS\Heart.blp
			func = function() -- yeah .. well .. was just a little bored, maybe a little easter egg \(n_n)/
				if GetTime() > throttle_playSound then throttle_playSound = GetTime() + 3
					local randomSound1 = math.random(1, 11); local descEnd = "|r|cffB6CA00.wav\")|r"; local descInterface = "/run |cffB6CA00PlaySoundFile(\"Sound\\\\Interface\\\\|r|cff71D5FF"; local descSpell = "/run |cffB6CA00PlaySoundFile(\"Sound\\\\Spells\\\\|r|cff71D5FF" -- "\\\\" -> \\
					if randomSound1 <= 10 then local randomSound2 = math.random(1, 10); -- For some reason the color UI escape code gets broken off by the 2nd one in soundPath; had to do it again after that 2nd one
						if	   randomSound2 >= 1 and randomSound2 <= 3 then PlaySoundFile("Sound\\Interface\\LevelUp.wav"); soundPath = descInterface.."LevelUp"..descEnd; -- ...\Data\common.MPQ\Sound\Interface\LevelUp.wav -- Player Leveled Up
						elseif randomSound2 >= 4 and randomSound2 <= 6 then PlaySoundFile("Sound\\Interface\\iQuestComplete.wav"); soundPath = descInterface.."iQuestComplete"..descEnd; -- ...\Data\common.MPQ\Sound\Interface\iQuestComplete.wav -- Quest Comepleted
						elseif randomSound2 >= 7 and randomSound2 <= 8 then PlaySoundFile("Sound\\Spells\\AchievmentSound1.wav"); soundPath = descSpell.."AchievmentSound1"..descEnd; -- ...\Data\common.MPQ\Sound\Spells\AchievmentSound1.wav -- Achievement Gained
						elseif randomSound2 >= 9 and randomSound2 <= 10 then PlaySoundFile("Sound\\Spells\\Resurrection.wav"); soundPath = descSpell.."Resurrection"..descEnd; -- ...\Data\common.MPQ\Sound\Spells\Resurrection.wav -- Resurrection
						end
					else local randomSound2 = math.random(1, 4)
						if	   randomSound2 == 1 then local randomSound3 = math.random(1, 3); local a = "Sound\\Spells\\"
							if	   randomSound3 == 1 then PlaySoundFile(a.."ValentineFirework.wav"); soundPath = descSpell.."ValentineFirework"..descEnd; -- ...\Data\common.MPQ\Sound\Spells\ValentineFirework.wav
							elseif randomSound3 == 2 then PlaySoundFile(a.."valentines_brokenheart.wav"); soundPath = descSpell.."valentines_brokenheart"..descEnd;
							elseif randomSound3 == 3 then PlaySoundFile(a.."valentines_lookingforloveheart.wav"); soundPath = descSpell.."valentines_lookingforloveheart"..descEnd;
							end
						elseif randomSound2 == 2 then local randomSound3 = math.random(1, 8); local b = "Sound\\Character\\BloodElf\\BloodElfFemale"; local descBelf = "/run |cffB6CA00PlaySoundFile(\"Sound\\\\Character\\\\BloodElf\\\\BloodElfFemale|r|cff71D5FF"
							if	   randomSound3 == 1 then PlaySoundFile(b.."Flirt01.wav"); soundPath = descBelf.."Flirt01"..descEnd; -- ...\Data\enGB\patch-enGB.MPQ\Sound\Character\BloodElf\BloodElfFemaleFlirt01.wav
							elseif randomSound3 == 2 then PlaySoundFile(b.."Flirt02.wav"); soundPath = descBelf.."Flirt02"..descEnd;
							elseif randomSound3 == 3 then PlaySoundFile(b.."Flirt04.wav"); soundPath = descBelf.."Flirt04"..descEnd;
							elseif randomSound3 == 4 then PlaySoundFile(b.."Flirt05.wav"); soundPath = descBelf.."Flirt05"..descEnd;
							elseif randomSound3 == 5 then PlaySoundFile(b.."Flirt10.wav"); soundPath = descBelf.."Flirt10"..descEnd;
							elseif randomSound3 == 6 then PlaySoundFile(b.."Flirt11.wav"); soundPath = descBelf.."Flirt11"..descEnd;
							elseif randomSound3 == 7 then PlaySoundFile(b.."Flirt13.wav"); soundPath = descBelf.."Flirt13"..descEnd;
							elseif randomSound3 == 8 then PlaySoundFile(b.."Beg01.wav"); soundPath = descBelf.."Beg01"..descEnd;
							end
						elseif randomSound2 == 3 then PlaySoundFile("Sound\\Creature\\Paletress\\AC_Paletress_Death01.wav"); soundPath = "/run |cffB6CA00PlaySoundFile(\"Sound\\\\Creature\\\\Paletress\\\\|r|cff71D5FFAC_Paletress_Death01"..descEnd; -- ...\Data\enGB\patch-enGB.MPQ\Sound\Creature\Paletress\AC_Paletress_Death01.wav
						elseif randomSound2 == 4 then local randomSound3 = math.random(1, 8); local c = "Sound\\Creature\\Paletress\\AC_Paletress_Wound"; local descPaletress = "/run |cffB6CA00PlaySoundFile(\"Sound\\\\Creature\\\\Paletress\\\\|r|cff71D5FF"
							if	   randomSound3 == 1 then PlaySoundFile(c.."Light03.wav"); soundPath = descPaletress.."****03"..descEnd;
							elseif randomSound3 == 2 then PlaySoundFile(c.."Medium01.wav"); soundPath = descPaletress.."****01"..descEnd;
							elseif randomSound3 == 3 then PlaySoundFile(c.."Heavy01.wav"); soundPath = descPaletress.."****01"..descEnd;
							elseif randomSound3 == 4 then PlaySoundFile(c.."Heavy02.wav"); soundPath = descPaletress.."****02"..descEnd;
							elseif randomSound3 == 5 then PlaySoundFile(c.."Heavy03.wav"); soundPath = descPaletress.."****03"..descEnd;
							elseif randomSound3 == 6 then PlaySoundFile(c.."Critical01.wav"); soundPath = descPaletress.."****01"..descEnd;
							elseif randomSound3 == 7 then PlaySoundFile(c.."Critical02.wav"); soundPath = descPaletress.."****02"..descEnd;
							elseif randomSound3 == 8 then PlaySoundFile(c.."Critical03.wav"); soundPath = descPaletress.."****03"..descEnd;
							end
						end
					end
				end
			end,
			disabled = "OptionsDisabled",
		},
		executePrintRawLevelTimes = {
			type = "execute",
			order = 17,
			name = "|TInterface\\Icons\\INV_Misc_Note_01:18:18:"..iconCropped.."|t Raw |cffFFFFFFLevel Times|r",
			func = function()
				if not ReadySetDing.db.char.levelTimeList or #ReadySetDing.db.char.levelTimeList == 0 then print("|cffADFF2FReadySet|rDing: |cffF6ADC6["..L["No Level Times Found"].."]|r")
				end
				for i = 2, maxLevel do
					if ReadySetDing.db.char.levelTimeList[i] then print("|cffADFF2FReadySet|rDing: Raw LevelTime Level |cffF6ADC6"..(i-1).."|r - |cff71D5FF"..i.."|r: |cffB6CA00"..ReadySetDing.db.char.levelTimeList[i].."|r")
					end
				end
			end,
			disabled = "OptionsDisabled",
		},
		executePrintRawTotalTimes = {
			type = "execute",
			order = 18,
			name = "|TInterface\\Icons\\INV_Misc_Note_01:18:18:"..iconCropped.."|t Raw |cffFFFFFFTotal Times|r",
			func = function()
				if not ReadySetDing.db.char.levelTimeList or #ReadySetDing.db.char.levelTimeList == 0 then print("|cffADFF2FReadySet|rDing: |cffF6ADC6["..L["No Level Times Found"].."]|r")
				end
				for i = 2, maxLevel do
					if ReadySetDing.db.char.levelTimeList[i] then print("|cffADFF2FReadySet|rDing: Raw TotalTime Level |cff71D5FF"..i.."|r: |cffB6CA00"..ReadySetDing.db.char.totalTimeList[i].."|r")
					end
				end
			end,
			disabled = "OptionsDisabled",
		},
		descriptionPlaySound = {
			type = "description",
			order = 19,
			name = function() if GetTime() < throttle_playSound then return ""..soundPath else return ""; end; end, -- Sound Path Description
		},
		descriptionSpacing = {
			type = "description",
			order = 20,
			name = "\n",
		},
		descriptionIcon = {
			type = "description",
			order = 21,
			name = function() return "|TInterface\\AddOns\\ReadySetDing\\Images\\Windows7:64:64:0:-60|t |TInterface\\AddOns\\ReadySetDing\\Images\\ReadySet7:32:128:0:-95|t" end,
		},
	},
}

local optionsProfiles = { -- How to not show Profiles in a "group"? Its always shown in a tree/select/tab group .. then it gets a dark background
	type = "group",
	name = "",
	args = {
		profiles = {
			type = "group",
			name = "",
			inline = true,
			args = {
				profiles = {
					type = "group",
					name = "",
				},
			},
		},
	},
}

--	Blizzard GUI Defaults
local defaults = {
	profile = { -- "ReadySetDing.db.defaults.profile.*"
		enableAddOn = true,
		Screenshot = false,
		AutoGratz = false,
		BNetBroadcast = false,
		normalAnnounce = true,
		guildAnnounce = false,
		dingMessage = "Ding! "..L["Level"].." [LEVEL] in [TIME]",

		AllAchievements = false,
		skipLevelAchievement = false,
		Debug = false, -- /run ReadySetDing.db.defaults.profile.Debug = true -- For Debug purpose
		screenshotDelay = 1,
		autoGratzDelay = 0,
		autoGratzCooldown = 60,
		autoGratzLengthLimit = 10,
		autoGratzMsg1 = "gratz [NAME]",
		autoGratzMsg2 = "grats",
		autoGratzMsg3 = "lol gz",
		autoGratzMsg4 = "gz =)",
		autoGratzMsg5 = "gz",

		Timer = false,
	}, -- Shouldnt use an "execute" button option with "ReadySetDing.db:ResetDB("Default")" because that would also delete the preciousss Level Time data; Also cant use "ReadySetDing.db.profile:ResetDB("Default")" [Error: attempt to call method 'ResetDB' (a nil value)]
	char = {
		deathCount = 0,
		deathCountTotal = 0,
	},
}

	--------------------------------------------------
	-----  02 OnInitialize, OnEnable, OnDisable  ----- ----- ----- ----- ----- ----- ----- ----- ----- ----- ----- ----- ----- ----- ----- ----- ----- ----- ----- ----- 
	--------------------------------------------------
function ReadySetDing:OnInitialize() -- Called when the addon is loaded
--	Creates a new database object that can be used to handle database settings and profiles -- http://www.wowace.com/addons/ace3/pages/api/ace-db-3-0/
	self.db = LibStub("AceDB-3.0"):New("ReadySetDingDB", defaults, "Default") -- , "Default" --> true (?)

--	Register an options table with the AceConfig registry -- http://www.wowace.com/addons/ace3/pages/api/ace-config-registry-3-0/
	local ACR = LibStub("AceConfigRegistry-3.0")
	ACR:RegisterOptionsTable("appReadySetDing", optionsMain)
	ACR:RegisterOptionsTable("appRSD_Advanced", optionsAdvanced)
	ACR:RegisterOptionsTable("appRSD_Timer", optionsTimer)
	ACR:RegisterOptionsTable("appRSD_About", optionsAbout)
	ACR:RegisterOptionsTable("appRSD_Profiles", optionsProfiles)
	
--	Add an options table into the Blizzard Interface Options panel -- http://www.wowace.com/addons/ace3/pages/api/ace-config-dialog-3-0/	
	local ACD = LibStub("AceConfigDialog-3.0"); local optionsMainName = "Ready|cffADFF2FSet|r|cffFFFFFFDing|r  |TInterface\\Icons\\Spell_Holy_BorrowedTime:18:18:"..iconCropped.."|t"
	self.optionsFrame = ACD:AddToBlizOptions("appReadySetDing", optionsMainName) -- Position: In Blizzard AddOn Options List; -- "self.optionsFrame" used for "InterfaceOptionsFrame_OpenToCategory"
	ACD:AddToBlizOptions("appRSD_Advanced", "|TInterface\\Icons\\Trade_Engineering:18:18:"..iconCropped.."|t Advanced", optionsMainName)
	ACD:AddToBlizOptions("appRSD_Timer", "|TInterface\\Icons\\Spell_Holy_BorrowedTime:18:18:"..iconCropped.."|t Instance Timer", optionsMainName)
	ACD:AddToBlizOptions("appRSD_About", "|TInterface\\Icons\\INV_Misc_QuestionMark:18:18:"..iconCropped.."|t About", optionsMainName)
	ACD:AddToBlizOptions("appRSD_Profiles", "|TInterface\\Icons\\INV_Misc_Note_01:18:18:"..iconCropped.."|t Profiles", optionsMainName)
	
--	Get/Create a option table that you can use in your addon to control the profiles of AceDB-3.0 -- http://www.wowace.com/addons/ace3/pages/api/ace-dboptions-3-0/
	optionsProfiles.args.profiles.args.profiles = LibStub("AceDBOptions-3.0"):GetOptionsTable(self.db) -- Dont rly understand the "group" it creates

--	Register chat commands -- http://www.wowace.com/addons/ace3/pages/api/ace-console-3-0/
	self:RegisterChatCommand("rsd", "slashCommand")
	self:RegisterChatCommand("readyset", "slashCommand")
	self:RegisterChatCommand("readysetding", "slashCommand")
	
--	Player Info; In the rare event the AddOn was set to Disabled on a profile before it even got to "OnEnable()" once; i.e. "self.db.profile.enableAddOn == false" and "playerLevel == nil"
	self.db.char.playerName = UnitName("player"); playerName = UnitName("player") -- Name of Player
	self.db.char.playerLevel = UnitLevel("player"); playerLevel = UnitLevel("player") -- Level of Player
--	self.db.char.playerFaction, _ = UnitFactionGroup("player") -- Faction of Player
--	local _, englishClassPlayer = UnitClass("player") -- Class of Player
	expansionLevel = GetAccountExpansionLevel()
--	local numGuildMembers = GetNumGuildMembers() -- Number of Guildmembers

	if self.db.profile.enableAddOn == false then
		if self.db.profile.Debug == true then self:Print("Initialized, Disabling .. (|cff71D5FFOnInitialize|r)"); end -- For Debug purpose
		self:Disable() -- Turn AddOn off again at start if it was turned off at login/reload
	elseif self.db.profile.enableAddOn == true then
		if self.db.profile.Debug == true then self:Print("Initialized (|cff71D5FFOnInitialize|r)"); end
	end
end

function ReadySetDing:OnEnable() -- Called when the addon is enabled
--	Subscribe to Events
	self:RegisterEvent("PLAYER_LEVEL_UP")
	self:RegisterEvent("TIME_PLAYED_MSG")
	self:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED") -- Player deaths, Instance Timer
	self:RegisterEvent("CHAT_MSG_CHANNEL_NOTICE") -- Instance Timer
	self:RegisterEvent("CHAT_MSG_MONSTER_YELL") -- Instance Timer
	self:RegisterEvent("CHAT_MSG_PARTY") -- Auto Gratz
	self:RegisterEvent("CHAT_MSG_GUILD") -- Auto Gratz
	self:RegisterEvent("CHAT_MSG_GUILD_ACHIEVEMENT") -- Auto Gratz
--	self:RegisterEvent("GUILD_ROSTER_UPDATE")
	
	self:ScheduleTimer(function() -- http://www.wowace.com/addons/ace3/pages/api/ace-timer-3-0/
		if self.db.profile.enableAddOn == true and TPM_totalTime == 0 then RequestTimePlayed() -- If ReadySetDing was off at start and enabled afterwards, it has to request /played again, since it was Disabled() ...
			if self.db.profile.Debug == true then self:Print("Couldn't find \"|cff71D5FFTIME_PLAYED_MSG|r\" after 7 seconds delay. Calling \"|cff71D5FFRequestTimePlayed()|r\"... (|cff71D5FFOnEnable|r)")
			end
		elseif self.db.profile.enableAddOn == true and TPM_totalTime > 0 and self.db.profile.Debug == true then
			self:Print("\"|cff71D5FFTIME_PLAYED_MSG|r\" fired. Skipped \"|cff71D5FFRequestTimePlayed()|r\". (|cff71D5FFOnEnable|r)")
		end
	end, 7) -- Delay the request for 7seconds(slow computers need 3-5s), so that it waits for other AddOns first that want to request /played

--	Define Arrays if undefined
	if not self.db.char.levelTimeList then self.db.char.levelTimeList = {}; end
	if not self.db.char.totalTimeList then self.db.char.totalTimeList = {}; end
--	Fix: variable namechange v0.60, keep data from v0.60; failed -> fixed in v0.61
	if self.db.char.timeDingList and #self.db.char.levelTimeList == 0 then self.db.char.levelTimeList = self.db.char.timeDingList; end

	if self.db.profile.Debug == true then self:Print("Enabled (|cff71D5FFOnEnable|r)"); end -- For Debug purpose
end 

function ReadySetDing:OnDisable() -- Called when the addon is disabled
	self:UnregisterAllEvents() -- Unsubscribe from all Events
	if self.db.profile.Debug == true then self:Print("Disabled (|cff71D5FFOnDisable|r)"); end -- For Debug purpose
end

	-----------------------------------
	-----  03  FUNCTION HANDLERS  ----- ----- ----- ----- ----- ----- ----- ----- ----- ----- ----- ----- ----- ----- ----- ----- ----- ----- ----- ----- ----- ----- ----- 
	-----------------------------------

function ReadySetDing:slashCommand(input) -- Process the slash command ('input' contains whatever follows the slash command)
	if not input or string.trim(input) == "" then InterfaceOptionsFrame_OpenToCategory(self.optionsFrame)
	else InterfaceOptionsFrame_OpenToCategory(self.optionsFrame) -- Instead of: /readysetding "ChatCommand", it will always go to options, since I don't understand "HandleCommand" ..
	--	LibStub("AceConfigCmd-3.0").HandleCommand(ReadySetDing, "rsd", "appReadySetDing") -- no idea how this works -- http://www.wowace.com/addons/ace3/pages/api/ace-config-cmd-3-0/
	end
end

function ReadySetDing:OptionsDisabled() -- Disables(gray out) options when AddOn disabled
	if ReadySetDing.db.profile.enableAddOn == true then return false; else return true; end
end

function RSD_Screenshot() -- A little)(1-2seconds) delay to show the LevelUp animation and Ding message bubble
	if ReadySetDing.db.profile.Screenshot == true then ReadySetDing:ScheduleTimer(function() Screenshot(); end, ReadySetDing.db.profile.screenshotDelay); end
end

function RSD_expansionLimitLevel(info)
	local nextLevel
	if	   expansionLevel == 3 and playerLevel < 85 then nextLevel = playerLevel + 1; maxLevel = 85 -- Cataclysm
	elseif expansionLevel == 2 and playerLevel < 80 then nextLevel = playerLevel + 1; maxLevel = 80 -- Wrath of the Lich King
	elseif expansionLevel == 1 and playerLevel < 70 then nextLevel = playerLevel + 1; maxLevel = 70 -- The Burning Crusade
	elseif expansionLevel == 0 and playerLevel < 60 then nextLevel = playerLevel + 1; maxLevel = 60 -- Classic / Vanilla
	else nextLevel = "[Reached Max Level]"
	end
	if info == "exampleNextLevel" then return nextLevel
	elseif info == "examplePreviousLevel" then return playerLevel
	elseif info == "remainLevels" then return maxLevel - playerLevel
	end
end

function RSD_dingTimes()
	if not ReadySetDing.db.char.levelHistoryStrJoin then ReadySetDing.db.char.levelHistoryStrJoin = "** |cffF6ADC6["..L["No Level Times Found"].."]|r **"; end
	if not ReadySetDing.db.char.levelHistory then ReadySetDing.db.char.levelHistory = {}; end -- Define array
	for i = 2, 80 do
		if ReadySetDing.db.char.levelTimeList[i] then
			for j = 1, 20 do
				if not ReadySetDing.db.char.levelHistory[j] then ReadySetDing.db.char.levelHistory[j] = ""; end
				if ReadySetDing.db.char.levelCounterA == j then ReadySetDing.db.char.levelHistory[j] = L["Level"].." "..(i-1).." - |cff71D5FF"..i.."|r:  |cffB6CA00"..RSD_TimetoString(ReadySetDing.db.char.levelTimeList[i]).."|r        "..L["Total"]..":  |cff71D5FF"..RSD_TimetoString(ReadySetDing.db.char.totalTimeList[i]).."|r"
				end
			end
			ReadySetDing.db.char.levelHistoryStrJoin = string.join("\n", -- 1 long string with linebreaks( \n ) as delimiter
				ReadySetDing.db.char.levelHistory[1], ReadySetDing.db.char.levelHistory[2], ReadySetDing.db.char.levelHistory[3], ReadySetDing.db.char.levelHistory[4], ReadySetDing.db.char.levelHistory[5],
				ReadySetDing.db.char.levelHistory[6], ReadySetDing.db.char.levelHistory[7], ReadySetDing.db.char.levelHistory[8], ReadySetDing.db.char.levelHistory[9], ReadySetDing.db.char.levelHistory[10],
				ReadySetDing.db.char.levelHistory[11], ReadySetDing.db.char.levelHistory[12], ReadySetDing.db.char.levelHistory[13], ReadySetDing.db.char.levelHistory[14], ReadySetDing.db.char.levelHistory[15],
				ReadySetDing.db.char.levelHistory[16], ReadySetDing.db.char.levelHistory[17], ReadySetDing.db.char.levelHistory[18], ReadySetDing.db.char.levelHistory[19], ReadySetDing.db.char.levelHistory[20])
		end
	end
return ReadySetDing.db.char.levelHistoryStrJoin
end

function RSD_addedTime() -- called from fairly much everywhere
	return GetTime() - lastRequestedPlayedTime
end

function RSD_timeDiff(info)
	local timeDiff
	if info == "exampleMsg" and ReadySetDing.db.char.levelTimeList[playerLevel] then timeDiff = ReadySetDing.db.char.levelTimeList[playerLevel] - (TPM_currentLevelTime+RSD_addedTime())
	elseif info == "dingMsg" and ReadySetDing.db.char.levelTimeList[playerLevel] and ReadySetDing.db.char.levelTimeList[playerLevel-1] then timeDiff = ReadySetDing.db.char.levelTimeList[playerLevel-1] - ReadySetDing.db.char.levelTimeList[playerLevel]
	else timeDiff = 0
	end
	if timeDiff < 0 then return RSD_TimetoString(-timeDiff).." slower" -- make positive if negative
	elseif timeDiff > 0 then return RSD_TimetoString(timeDiff).." faster"
	else return "[No TimeDiff Data]"
	end
end

function RSD_randomAutoGratzDelay()
	if ReadySetDing.db.profile.autoGratzDelay == 0 then return math.random(2, 10)
	else return ReadySetDing.db.profile.autoGratzDelay
	end
end

function RSD_randomAutoGratzMsg() -- forgot how _G[] or getglobal works ... otherwise this code could be more efficient =(
	local a = math.random(1, 5); local b
	if	   a == 1 then b = ReadySetDing.db.profile.autoGratzMsg1
	elseif a == 2 then b = ReadySetDing.db.profile.autoGratzMsg2
	elseif a == 3 then b = ReadySetDing.db.profile.autoGratzMsg3
	elseif a == 4 then b = ReadySetDing.db.profile.autoGratzMsg4
	elseif a == 5 then b = ReadySetDing.db.profile.autoGratzMsg5
	end; return b
end


function RSD_timeInstanceList()
	if not ReadySetDing.db.char.timeInstanceList then ReadySetDing.db.char.timeInstanceList = {}; end
	ReadySetDing.db.char.timeInstanceList[date("%Y.%m.%d.%H%M")] = realZone..": "..RSD_TimetoString(GetTime() - timeInstance)
end

function RSD_ReplaceText(msg, msgtype)
	local exampleDingMsg = ReadySetDing.db.profile.dingMessage; local dingMsg = ReadySetDing.db.profile.dingMessage
	local exampleAutoGratzMsg = ReadySetDing.db.profile.autoGratzMsg1; local autoGratzMsg = RSD_randomAutoGratzMsg()
	if msgtype == "exampleDingMsg" then
		exampleDingMsg = string.gsub(exampleDingMsg, "%[[Ll][Ee][Vv][Ee][Ll]%-%]", "|cffF6ADC6"..RSD_expansionLimitLevel("examplePreviousLevel").."|r")
		exampleDingMsg = string.gsub(exampleDingMsg, "%[[Ll][Ee][Vv][Ee][Ll]%]", "|cffADFF2F"..RSD_expansionLimitLevel("exampleNextLevel").."|r")
		exampleDingMsg = string.gsub(exampleDingMsg, "%[[Ll][Ee][Vv][Ee][Ll]%#%]", "|cffF6ADC6"..RSD_expansionLimitLevel("remainLevels").."|r")
		exampleDingMsg = string.gsub(exampleDingMsg, "%[[Ll][Ee][Vv][Ee][Ll]%+%]", "|cffF6ADC6"..maxLevel.."|r")
		exampleDingMsg = string.gsub(exampleDingMsg, "%[[Tt][Ii][Mm][Ee]%]", "|cff71D5FF"..RSD_TimetoString(TPM_currentLevelTime+RSD_addedTime()).."|r")
		exampleDingMsg = string.gsub(exampleDingMsg, "%[[Tt][Oo][Tt][Aa][Ll]%]", "|cff71D5FF"..RSD_TimetoString(TPM_totalTime+RSD_addedTime()).."|r")
		exampleDingMsg = string.gsub(exampleDingMsg, "%[[Dd][Ii][Ff][Ff]%]", "|cff71D5FF"..RSD_timeDiff("exampleMsg").."|r")
		if ReadySetDing.db.char.totalTimeList[playerLevel-5] then exampleDingMsg = string.gsub(exampleDingMsg, "%[[Ss][Pp][Ee][Ee][Dd]%]", "|cff58ACFA"..string.format("%.2f", ((TPM_totalTime+RSD_addedTime())-ReadySetDing.db.char.totalTimeList[playerLevel-5])/18000).."|r")
		else exampleDingMsg = string.gsub(exampleDingMsg, "%[[Ss][Pp][Ee][Ee][Dd]%]", "|cffF6ADC6[No LevelSpeed Data]|r"); end -- could also do "if playerLevel > 0 then" but as you can see im really scared of dividing by zero
		if playerLevel-1 ~= 0 then exampleDingMsg = string.gsub(exampleDingMsg, "%[[Ss][Pp][Ee][Ee][Dd]%+%]", "|cff58ACFA"..string.format("%.2f", (TPM_totalTime+RSD_addedTime())/(3600*(playerLevel-1))).."|r")
		else exampleDingMsg = string.gsub(exampleDingMsg, "%[[Ss][Pp][Ee][Ee][Dd]%+%]", "|cffF6ADC6[No LevelSpeed Data]|r"); end
		exampleDingMsg = string.gsub(exampleDingMsg, "%[[Dd][Ee][Aa][Tt][Hh][Ss]%]", "|cffFF6347"..ReadySetDing.db.char.deathCount.."|r")
		exampleDingMsg = string.gsub(exampleDingMsg, "%[[Dd][Ee][Aa][Tt][Hh][Ss]%+%]", "|cffFF6347"..ReadySetDing.db.char.deathCountTotal.."|r")
		exampleDingMsg = string.gsub(exampleDingMsg, "%[[Nn][Aa][Mm][Ee]%]", "|cffADFF2F"..playerName.."|r")
		if IsInGuild() == 1 then exampleDingMsg = string.gsub(exampleDingMsg, "%[[Gg][Uu][Ii][Ll][Dd]%]", "|cff40FF40"..GetGuildInfo("player").."|r")
		else exampleDingMsg = string.gsub(exampleDingMsg, "%[[Gg][Uu][Ii][Ll][Dd]%]", "|cffF6ADC6[Not in Guild]|r"); end
		exampleDingMsg = string.gsub(exampleDingMsg, "%[[Zz][Oo][Nn][Ee]%]", "|cff58ACFA"..GetRealZoneText().."|r")
		
		exampleDingMsg = string.gsub(exampleDingMsg, "%{[Ss][Tt][Aa][Rr]%}", "|TInterface\\TargetingFrame\\UI-RaidTargetingIcon_1:12|t")
		exampleDingMsg = string.gsub(exampleDingMsg, "%{[Cc][Ii][Rr][Cc][Ll][Ee]%}", "|TInterface\\TargetingFrame\\UI-RaidTargetingIcon_2:12|t")
		exampleDingMsg = string.gsub(exampleDingMsg, "%{[Dd][Ii][Aa][Mm][Oo][Nn][Dd]%}", "|TInterface\\TargetingFrame\\UI-RaidTargetingIcon_3:12|t")
		exampleDingMsg = string.gsub(exampleDingMsg, "%{[Tt][Rr][Ii][Aa][Nn][Gg][Ll][Ee]%}", "|TInterface\\TargetingFrame\\UI-RaidTargetingIcon_4:12|t")
		exampleDingMsg = string.gsub(exampleDingMsg, "%{[Mm][Oo][Oo][Nn]%}", "|TInterface\\TargetingFrame\\UI-RaidTargetingIcon_5:12|t")
		exampleDingMsg = string.gsub(exampleDingMsg, "%{[Ss][Qq][Uu][Aa][Rr][Ee]%}", "|TInterface\\TargetingFrame\\UI-RaidTargetingIcon_6:12|t")
		exampleDingMsg = string.gsub(exampleDingMsg, "%{[Cc][Rr][Oo][Ss][Ss]%}", "|TInterface\\TargetingFrame\\UI-RaidTargetingIcon_7:12|t")
		exampleDingMsg = string.gsub(exampleDingMsg, "%{[Ss][Kk][Uu][Ll][Ll]%}", "|TInterface\\TargetingFrame\\UI-RaidTargetingIcon_8:12|t")
		return exampleDingMsg
	elseif msgtype == "DingMsg" then
		dingMsg = string.gsub(dingMsg, "%[[Ll][Ee][Vv][Ee][Ll]%-%]", playerLevel-1)
		dingMsg = string.gsub(dingMsg, "%[[Ll][Ee][Vv][Ee][Ll]%]", playerLevel)
		dingMsg = string.gsub(dingMsg, "%[[Ll][Ee][Vv][Ee][Ll]%#%]", RSD_expansionLimitLevel("remainLevels"))
		dingMsg = string.gsub(dingMsg, "%[[Ll][Ee][Vv][Ee][Ll]%+%]", maxLevel)
		dingMsg = string.gsub(dingMsg, "%[[Tt][Ii][Mm][Ee]%]", RSD_TimetoString(levelTime2))
		dingMsg = string.gsub(dingMsg, "%[[Tt][Oo][Tt][Aa][Ll]%]", RSD_TimetoString(TPM_totalTime))
		dingMsg = string.gsub(dingMsg, "%[[Dd][Ii][Ff][Ff]%]", RSD_timeDiff("dingMsg"))
		if ReadySetDing.db.char.totalTimeList[playerLevel-5] then dingMsg = string.gsub(dingMsg, "%[[Ss][Pp][Ee][Ee][Dd]%]", string.format("%.2f", (TPM_totalTime-ReadySetDing.db.char.totalTimeList[playerLevel-5])/18000))
		else dingMsg = string.gsub(dingMsg, "%[[Ss][Pp][Ee][Ee][Dd]%]", "[No Last 5 LevelSpeed Data]"); end
		if playerLevel-1 ~= 0 then dingMsg = string.gsub(dingMsg, "%[[Ss][Pp][Ee][Ee][Dd]%+%]", string.format("%.2f", TPM_totalTime/(3600*(playerLevel-1))))
		else dingMsg = string.gsub(dingMsg, "%[[Ss][Pp][Ee][Ee][Dd]%+%]", "[No LevelSpeed Data]"); end
		dingMsg = string.gsub(dingMsg, "%[[Dd][Ee][Aa][Tt][Hh][Ss]%]", ReadySetDing.db.char.deathCount)
		dingMsg = string.gsub(dingMsg, "%[[Dd][Ee][Aa][Tt][Hh][Ss]%+%]", ReadySetDing.db.char.deathCountTotal)
		dingMsg = string.gsub(dingMsg, "%[[Nn][Aa][Mm][Ee]%]", playerName)
		if IsInGuild() == 1 then dingMsg = string.gsub(dingMsg, "%[[Gg][Uu][Ii][Ll][Dd]%]", GetGuildInfo("player"))
		else dingMsg = string.gsub(dingMsg, "%[[Gg][Uu][Ii][Ll][Dd]%]", "[Not in Guild]"); end
		dingMsg = string.gsub(dingMsg, "%[[Zz][Oo][Nn][Ee]%]", GetRealZoneText())
		return dingMsg
	elseif msgtype == "ExampleAutoGratzMsg" then
		exampleAutoGratzMsg = string.gsub(exampleAutoGratzMsg, "%[[Nn][Aa][Mm][Ee]%]", "|cffADFF2F<Name>|r")
		return exampleAutoGratzMsg
	elseif msgtype == "AutoGratzMsg" then
		autoGratzMsg = string.gsub(autoGratzMsg, "%[[Nn][Aa][Mm][Ee]%]", gratzName)
		return autoGratzMsg
	end
end

function RSD_TimetoString(time)
	local seconds = mod(floor(time),60)
	local minutes = mod(floor(time/60),60)
	local hours = mod(floor(time/3600),24)
	local days = floor(time/86400)
	if time >= 0 and time < 60 then
		if	   seconds > 1	then return seconds.." "..L["seconds"] -- Recruit-a-Friend(RAF) level granting ..?
		elseif seconds == 1 then return seconds.." "..L["second"]
		elseif seconds == 0 then return "an infinitesimal amount of time"; end -- I like PHD Comics :) [2010.08.20 Instantaneous Property]
	elseif time >= 60 and time < 3600 then -- Should not use the operator in "~= 1" (not specific enough), but "> 1" or ">= 2" instead
		if	   minutes == 1 then return minutes.." "..L["minute"] -- including seconds would be irrelevant or even annoying, moreover it might not be accurate with "GetTime() - lastTime" method for bigger amounts of time
		elseif minutes >= 2 then return minutes.." "..L["minutes"]; end
	elseif time >= 3600 and time < 86400 then
		if	   hours >= 2 and minutes >= 2 then return hours.." "..L["hours"]..", "..minutes.." "..L["minutes"] -- 2 most significant Units of Time
		elseif hours == 1 and minutes >= 2 then return hours.." "..L["hour"]..", "..minutes.." "..L["minutes"]
		elseif hours >= 2 and minutes == 1 then return hours.." "..L["hours"]..", "..minutes.." "..L["minute"]
		elseif hours == 1 and minutes == 1 then return hours.." "..L["hour"]..", "..minutes.." "..L["minute"]
		elseif hours == 1 and minutes == 0 then return hours.." "..L["hour"]
		elseif hours >= 2 and minutes == 0 then return hours.." "..L["hours"]; end
	elseif time >= 86400 then
		if	   days >= 2 and hours >= 2 then return days.." "..L["days"]..", "..hours.." "..L["hours"]
		elseif days == 1 and hours >= 2 then return days.." "..L["day"]..", "..hours.." "..L["hours"]
		elseif days >= 2 and hours == 1 then return days.." "..L["days"]..", "..hours.." "..L["hour"]
		elseif days == 1 and hours == 1 then return days.." "..L["day"]..", "..hours.." "..L["hour"]
		elseif days == 1 and hours == 0 then return days.." "..L["day"]
		elseif days >= 2 and hours == 0 then return days.." "..L["days"]; end
	elseif time < 0 then return "[Error: Time is Negative]"
	end
end

	--------------------------------
	-----  04  EVENT HANDLERS  ----- ----- ----- ----- ----- ----- ----- ----- ----- ----- ----- ----- ----- ----- ----- ----- ----- ----- ----- ----- ----- -----  ----- 
	--------------------------------
function ReadySetDing:PLAYER_LEVEL_UP(event, ...)
	PLU_level = select(1, ...) -- http://www.wowwiki.com/API_select
	playerDinged = true; RequestTimePlayed() -- /played -> "TIME_PLAYED_MSG" event
	if not self.db.char.levelCounterA or self.db.char.levelCounterA > 20 then self.db.char.levelCounterA = 0 -- Resets if leveled 21+ times
		if self.db.profile.Debug == true then self:Print("The LevelUp Counter doesn't exist yet, or exceeded 20; Changed back to 1."); end
	end self.db.char.levelCounterA = self.db.char.levelCounterA + 1
end

function ReadySetDing:TIME_PLAYED_MSG(event, ...)
	TPM_totalTime, TPM_currentLevelTime = select(1, ...); lastRequestedPlayedTime = GetTime()
	if playerDinged ~= true then TPM_totalTime2 = TPM_totalTime; TPM_currentLevelTime2 = TPM_currentLevelTime -- used to "guess" levelTime#1
	elseif playerDinged == true and (TPM_currentLevelTime >= 0 and TPM_currentLevelTime <= 5) then -- 5 seconds grace period wherein the AddOn thinks the player has recently dinged
	--	reset / refresh variables
		playerDinged = false; self.db.char.deathCount = 0 -- reset deathCount for in Ding Message variable
		self.db.char.playerLevel = UnitLevel("player"); playerLevel = PLU_level -- the UnitLevel("player") didnt update fast enough at the "PLAYER_LEVEL_UP" event ..

	--	A: Last undinged LevelTime + (dinged TotalTime - last undinged TotalTime); cant be used for in DingMsg examples, since it wont get refreshed (only when /played fires); GetTime() as in "addedTime" is used for that
		levelTime = TPM_currentLevelTime2 + (TPM_totalTime - TPM_totalTime2)
		TPM_totalTime2 = TPM_totalTime; TPM_currentLevelTime2 = TPM_currentLevelTime -- update time variables for next level
	--	B: TotalTime @ Ding - TotalTime @ previous Ding (more accurate)
		if self.db.char.totalTimeList[playerLevel-1] then
			levelTime2 = TPM_totalTime - self.db.char.totalTimeList[playerLevel-1]
		else levelTime2 = levelTime
		end

		for i = 2, maxLevel do -- update to list of times everytime you ding
			if playerLevel == i then -- Look for matching playerLevel and save it to the array
				self.db.char.levelTimeList[i] = levelTime2
				self.db.char.totalTimeList[i] = TPM_totalTime
			end
		end
		
		--	LibStub("AceConfigRegistry-3.0"):NotifyChange("appReadySetDing") -- refresh config failed -> copy whole codeblock
		if not self.db.char.levelHistoryStrJoin then self.db.char.levelHistoryStrJoin = "** |cffF6ADC6["..L["No Level Times Found"].."]|r **"; end
		if not self.db.char.levelHistory then self.db.char.levelHistory = {}; end -- Define array
		for i = 2, maxLevel do
			if self.db.char.levelTimeList[i] then
				for j = 1, 20 do
					if not self.db.char.levelHistory[j] then self.db.char.levelHistory[j] = ""; end
					if self.db.char.levelCounterA == j then self.db.char.levelHistory[j] = "  "..L["Level"].." |cffF6ADC6"..(i-1).."|r - |cff71D5FF"..i.."|r:  |cffB6CA00"..RSD_TimetoString(self.db.char.levelTimeList[i]).."|r        "..L["Total"]..":  |cff71D5FF"..RSD_TimetoString(self.db.char.totalTimeList[i]).."|r"
					end
				end
				self.db.char.levelHistoryStrJoin = string.join("\n", -- 1 long string with linebreaks( \n ) as delimiter
					self.db.char.levelHistory[1], self.db.char.levelHistory[2], self.db.char.levelHistory[3], self.db.char.levelHistory[4], self.db.char.levelHistory[5],
					self.db.char.levelHistory[6], self.db.char.levelHistory[7], self.db.char.levelHistory[8], self.db.char.levelHistory[9], self.db.char.levelHistory[10],
					self.db.char.levelHistory[11], self.db.char.levelHistory[12], self.db.char.levelHistory[13], self.db.char.levelHistory[14], self.db.char.levelHistory[15],
					self.db.char.levelHistory[16], self.db.char.levelHistory[17], self.db.char.levelHistory[18], self.db.char.levelHistory[19])
			end
		end
	
	--	Announce Ding Message
		if (self.db.profile.skipLevelAchievement == true and (string.sub(playerLevel, 2, 2) == "0" or playerLevel == 85)) or self.db.profile.skipLevelAchievement == false then -- [Skip Level Achievements] Condition
			if select(2, IsInInstance()) == "none" and self.db.profile.normalAnnounce == true then
				if GetNumPartyMembers() > 1 then SCM(RSD_ReplaceText(self.db.profile.dingMessage, "DingMsg"), "PARTY"); -- [Normal Announce: Party] Feature; find out first if in a party
				else SCM(RSD_ReplaceText(self.db.profile.dingMessage, "DingMsg"), "SAY"); -- [Normal Announce: Say] Feature
				end
			elseif select(2, IsInInstance()) == "party" and self.db.profile.normalAnnounce == true then SCM(RSD_ReplaceText(self.db.profile.dingMessage, "DingMsg"), "PARTY"); -- [Normal Announce: Instance Party]
			elseif select(2, IsInInstance()) == "raid" and self.db.profile.normalAnnounce == true then SCM(RSD_ReplaceText(self.db.profile.dingMessage, "DingMsg"), "RAID"); -- [Normal Announce: Raid] Feature
			elseif select(2, IsInInstance()) == "pvp" and self.db.profile.normalAnnounce == true then SCM(RSD_ReplaceText(self.db.profile.dingMessage, "DingMsg"), "BATTLEGROUND"); -- [Normal Announce: Battleground]
			end
			if self.db.profile.guildAnnounce == true and IsInGuild() == 1 then SCM(RSD_ReplaceText(self.db.profile.dingMessage, "DingMsg"), "GUILD"); end -- Guild Announce
			if self.db.profile.Screenshot == true then RSD_Screenshot(); end -- Screenshot Feature
			if self.db.profile.BNetBroadcast == true then local broadcastMsg = (select(3, BNGetInfo())); BNSetCustomMessage(RSD_ReplaceText(self.db.profile.dingMessage, "DingMsg")); BNSetCustomMessage(broadcastMsg); end -- Real ID Broadcast
		end
	end
end

function ReadySetDing:COMBAT_LOG_EVENT_UNFILTERED(event, ...)
	local _, event, _, _, _, _, destName = select(1, ...)
	if event == "UNIT_DIED" and destName == playerName then
		self.db.char.deathCount = self.db.char.deathCount + 1 -- [Deaths] variable for in DingMsg
		self.db.char.deathCountTotal = self.db.char.deathCountTotal + 1
	end

--#	Instance Timer
	if event == "UNIT_DIED" and self.db.profile.Timer == true and timeInstance > 0 and select(2, IsInInstance()) == "party" then
		if GetTime() > throttle_realZone then throttle_realZone = GetTime() + 60; realZone = GetRealZoneText(); end -- Make sure "realZone" is correct (with throttle/cooldown)
		if playerLevel >= 80 then -- Exclude: UK, ToC5, CoS, HoR (No/Multiple Boss Deaths)
			if destName == "Keristrasza" or destName == "Ley-Guardian Eregos" or destName == "King Ymiron" or destName == "Anub'arak" or destName == "Herald Volazj" or destName == "Cyanigosa" or destName == "The Prophet Tharon'ja" or
				destName == "The Prophet Tharon'ja " or destName == "Gal'darah" or destName == "Sjonnir The Ironshaper" or destName == "Loken" or destName == "Devourer of Souls" or destName == "Scourgelord Tyrannus" then
				SCM("["..GetRealZoneText().."] cleared in "..RSD_TimetoString(GetTime() - timeInstance), "PARTY")
			end RSD_timeInstanceList(); timeInstance = 0
		elseif playerLevel < 80 then
			--	[01-60] World of Warcraft (Vanilla) Instance
			if destName == "Taragaman the Hungerer" or destName == "Edwin VanCleef" or destName == "Mutanus the Devourer" or destName == "Archmage Arugal" or destName == "Aku'mai" or
				destName == "Bazil Thredd" or destName == "Charlga Razorflank" or destName == "Mekgineer Thermaplugg" or destName == "Amnennar the Coldbringer" or destName == "Bloodmage Thalnos" or
				destName == "Arcanist Doan" or destName == "Herod" or destName == "High Inquisitor Whitemane" or destName == "Archaedas" or destName == "Chief Ukorz Sandscalp" or
				destName == "Lord Vyletongue" or destName == "Razorlash" or destName == "Princess Theradras" or destName == "Shade of Eranikus" or destName == "High Interrogator Gerstahn" or destName == "Emperor Dagran Thaurissan" or
				destName == "Overlord Wyrmthalak" or destName == "Alzzin the Wildshaper" or destName == "Prince Tortheldrin" or destName == "King Gordok" or destName == "Darkmaster Gandling" or destName == "Baron Rivendare" or
			--	[60-70] The Burning Crusade Instance
				destName == "Nazan" or destName == "Keli'dan the Breaker" or destName == "Warchief Kargath Bladefist" or destName == "Quagmirran" or destName == "The Black Stalker" or
				destName == "Warlord Kalithresh" or destName == "Nexus-Prince Shaffar" or destName == "Exarch Maladaar" or destName == "Talon King Ikiss" or destName == "Murmur" or destName == "Warp Splinter" or
				destName == "Pathaleon the Calculator" or destName == "Harbinger Skyriss" or destName == "Epoch Hunter" or destName == "Aeonus" or
			--	[70-80] Wrath of the Lich King Instance
				destName == "Keristrasza" or destName == "Ley-Guardian Eregos" or destName == "King Ymiron" or destName == "Anub'arak" or destName == "Herald Volazj" or destName == "Cyanigosa" or destName == "The Prophet Tharon'ja" or
				destName == "The Prophet Tharon'ja " or destName == "Gal'darah" or destName == "Sjonnir The Ironshaper" or destName == "Loken" or destName == "Devourer of Souls" or destName == "Scourgelord Tyrannus" then
				if realZone == "Scarlet Monastery" then -- 1 zone, split in 4 parts (they really are in the same map file)
					if	   destName == "Bloodmage Thalnos" then SCM("[Scarlet Monastery: Graveyard] cleared in "..RSD_TimetoString(GetTime() - timeInstance), "PARTY") -- [27-37]
					elseif destName == "Arcanist Doan" then SCM("[Scarlet Monastery: Library] cleared in "..RSD_TimetoString(GetTime() - timeInstance), "PARTY") -- [30-40]
					elseif destName == "Herod" then SCM("[Scarlet Monastery: Armory] cleared in "..RSD_TimetoString(GetTime() - timeInstance), "PARTY") -- [32-42]
					elseif destName == "High Inquisitor Whitemane" then SCM("[Scarlet Monastery: Cathedral] cleared in "..RSD_TimetoString(GetTime() - timeInstance), "PARTY") -- [35-45] -- even if Herod is still alive and Whitemane dies, instance is considered completed by Blizz
					end
				elseif realZone == "Maraudon" then -- 1 zone, split in 3 parts
					if	   destName == "Lord Vyletongue" then SCM("[Maraudon: Purple Crystals] cleared in "..RSD_TimetoString(GetTime() - timeInstance), "PARTY"); timeInstance2 = timeInstance -- [39-49] -- another timer if group decides to continue instance
					elseif destName == "Razorlash" then SCM("[Maraudon: Orange Crystals] cleared in "..RSD_TimetoString(GetTime() - timeInstance), "PARTY"); timeInstance2 = timeInstance -- [41-51]
					elseif destName == "Princess Theradras" then if timeInstance2 > 0 then timeInstance = timeInstance2; end; SCM("[Maraudon: Pristine Waters] cleared in "..RSD_TimetoString(GetTime() - timeInstance), "PARTY"); -- [43-53]
					end
				elseif realZone == "Blackrock Depths" then -- 1 zone, split in 2 parts
					if	   destName == "High Interrogator Gerstahn" then SCM("[Blackrock Depths: Prison] cleared in "..RSD_TimetoString(GetTime() - timeInstance), "PARTY"); timeInstance2 = timeInstance -- [47-57]
					elseif destName == "Emperor Dagran Thaurissan" then if timeInstance2 > 0 then timeInstance = timeInstance2; end; SCM("[Blackrock Depths: Upper City] cleared in "..RSD_TimetoString(GetTime() - timeInstance), "PARTY"); -- [51-61]
					end
				elseif realZone == "Dire Maul" then -- what kind of map file is this? probably 1 zone, split into 3 parts
					if	   destName == "Alzzin the Wildshaper" then SCM("[Dire Maul: East] cleared in "..RSD_TimetoString(GetTime() - timeInstance), "PARTY");  -- [#53-63]
					elseif destName == "Prince Tortheldrin" then SCM("[Dire Maul: West] cleared in "..RSD_TimetoString(GetTime() - timeInstance), "PARTY");  -- [#55-65]
					elseif destName == "King Gordok" then SCM("[Dire Maul: North] cleared in "..RSD_TimetoString(GetTime() - timeInstance), "PARTY"); -- [#55-65]
					end
				elseif realZone == "Stratholme" then -- 1 zone, split in 2 parts
					if	   destName == "Balnazzar" then SCM("[Stratholme: Main Gate] cleared in "..RSD_TimetoString(GetTime() - timeInstance), "PARTY"); timeInstance2 = timeInstance -- [#55-65]
					elseif destName == "Baron Rivendare" then if timeInstance2 > 0 then timeInstance = timeInstance2; end; SCM("[Stratholme: Service Entrance] cleared in "..RSD_TimetoString(GetTime() - timeInstance), "PARTY"); -- [#55-65]
					end
				else SCM("["..GetRealZoneText().."] cleared in "..RSD_TimetoString(GetTime() - timeInstance), "PARTY");
				end
				RSD_timeInstanceList(); timeInstance = 0; timeInstance2 = 0
			end
		end
	end
end

function ReadySetDing:CHAT_MSG_CHANNEL_NOTICE(event, ...)
	local msg = select(1, ...)
	if msg == "YOU_CHANGED" then
		if select(2, IsInInstance()) == "party" and (timeInstance == 0 or GetTime() > timeInstance + 7200) then timeInstance = GetTime() -- how to know if not re-entering or quitted an instance? ..; will add a button to manually reset(+feedback inside)
			if self.db.profile.Debug == true then print("ReadySetDing: Instance Time = "..timeInstance); end
		end -- File-local Scope variable instead of the Ace3 database, since often after a previous session it would return insane/negative times with GetTime() (its the time since your computer was on); ofcourse reloading/relogging will purge the variable
	end
end

function ReadySetDing:CHAT_MSG_MONSTER_YELL(event, ...) -- Instance Timer
	local msg = select(1, ...)
	if self.db.profile.Timer == true and timeInstance > 0 then
		if KC_realZone == "Utgarde Keep" and msg == "No! I can do... better! I can..." then -- (Boss dies twice)
			SCM("["..GetRealZoneText().."] cleared in "..KC_TimetoString(GetTime() - timeInstance), "PARTY"); timeInstance = 0
		elseif KC_realZone == "The Culling of Stratholme" and msg == "Your journey has just begun, young prince. Gather your forces and meet me in the arctic land of Northrend. It is there that we shall settle the score between us. It is there that your true destiny will unfold." then -- (Boss doesn't die)
			SCM("["..GetRealZoneText().."] cleared in "..KC_TimetoString(GetTime()-timeInstance), "PARTY"); timeInstance = 0
		elseif KC_realZone == "Trial of the Champion" and msg == "No! I must not fail... again..." then -- (Boss dies x3); maybe shouldve checked against unitGUID...
			SCM("["..GetRealZoneText().."] cleared in "..KC_TimetoString(GetTime()-timeInstance), "PARTY"); timeInstance = 0
		elseif KC_realZone == "Halls of Reflection" and msg == "FIRE! FIRE!" then -- (no Boss; Escape Event)
			SCM("["..GetRealZoneText().."] cleared in "..KC_TimetoString(GetTime()-timeInstance), "PARTY"); timeInstance = 0
		end
	end
end

--	Auto Gratz events -- dont alt+tab with auto gratz on, it will spam all "queued" dings once you alt+tab back in
function ReadySetDing:CHAT_MSG_PARTY(event, ...) -- rather than checking for different names, just a global cooldown/throttle, since I suspect it would be abused fairly much
	local msg, player = select(1, ...)
	if self.db.profile.AutoGratz == true and player ~= playerName and string.find(msg, "[Dd][Ii][Nn][Gg]") and string.len(msg) <= self.db.profile.autoGratzLengthLimit and GetTime() > throttle_autoGratzP then
		gratzName = player; throttle_autoGratzP = GetTime() + self.db.profile.autoGratzCooldown; self:ScheduleTimer(function() SCM(RSD_ReplaceText(RSD_randomAutoGratzMsg(), "AutoGratzMsg"), "PARTY"); end, RSD_randomAutoGratzDelay())
	end
end

function ReadySetDing:CHAT_MSG_GUILD(event, ...)
	local msg, player = select(1, ...)
	if self.db.profile.AutoGratz == true and player ~= playerName and string.find(msg, "[Dd][Ii][Nn][Gg]") and string.len(msg) <= self.db.profile.autoGratzLengthLimit and GetTime() > throttle_autoGratzG then
		gratzName = player; throttle_autoGratzG = GetTime() + self.db.profile.autoGratzCooldown; self:ScheduleTimer(function() SCM(RSD_ReplaceText(RSD_randomAutoGratzMsg(), "AutoGratzMsg"), "GUILD"); end, RSD_randomAutoGratzDelay())
	end
end

function ReadySetDing:CHAT_MSG_GUILD_ACHIEVEMENT(event, ...)
	local msg, player = select(1, ...)
	if self.db.profile.AutoGratz == true and ((self.db.profile.gratzAllAchievements == false and string.find(msg, "Level")) or self.db.profile.gratzAllAchievements == true) and player ~= playerName and GetTime() > throttle_autoGratzG then
		gratzName = player; throttle_autoGratzG = GetTime() + self.db.profile.autoGratzCooldown; self:ScheduleTimer(function() SCM(RSD_ReplaceText(RSD_randomAutoGratzMsg(), "AutoGratzMsg"), "GUILD"); end, RSD_randomAutoGratzDelay())
	end
end

	-------------------------
	-----  END OF ADDON ----- ----- ----- ----- ----- ----- ----- ----- ----- ----- ----- ----- ----- ----- ----- ----- ----- ----- ----- ----- ----- ----- ----- -----
	-------------------------
--[[
# Version History
	v0.61	2010.10.14  Lots of Bugfixes (great feedback by Eincrou@WoWInterface); Code refactoring; Added even more DingMessage Variables
	v0.60	2010.10.13  First try at Localizations; Added more DingMessage variables, Leveling Speed, Instance Timer; Removed DingMessage Validate since you get a feedback example; coded messy because of v4.0.1 deadline
	v0.52	2010.09.04  Fixed Table of Contents (.TOC) Title; Added ReadySet7 Images; Cleaned up [Advanced] Options tab
	v0.51	2010.09.04	Removed Camera Max Distance by request, Code refactoring(Variable Scoping)
	v0.5	2010.09.01	Added Ding Emote, Real ID Broadcast, Ding Summary
	v0.4	2010.03.18	Added Custom Ding Message, Screenshot option
	v0.3	2010.01.29	Added GUI Options, Slash Commands, embeded Ace3 libs
	v0.2	2010.01.10	Released again, made some (stupid?) error
	v0.1	2010.01.10	Release
# GetIconInfo cheatsheet
	/dump (select(10, GetItemInfo(28528)))
	/dump (select(3, GetSpellInfo(47788)))
	/dump (select(10, GetAchievementInfo(3456)))
	/dump (select(2, GetMacroInfo(2)))
	/run print("\124TInterface\\Icons\\INV_Misc_Rune_01:32\124t")
# Colors
	LightSkyBlue = #87CEFA; GreenYellow = #ADFF2F; Tomato = #FF6347; Nadeshiko Pink = #F6ADC6; Misty Rose = #FFE4E1; LightPink = #FFB6C1
	Item: Legendary = #FF8000; Epic == #A335EE; Blue = 0070DD; Green = #1EFF00; White = #FFFFFF; Gray = #9D9D9D
	Level Difference: Red = #FF2020; Orange = #FF8040; Yellow = #FFFF00; Green = #40C040; Gray = #808080; Hostile Reaction = #BF0D0D; Friendly Reaction = #57A3FF
	Profession = #FFD000; Achievement = #FFFF00; Talent = #4E96F7; Ability = #71D5FF
# Links
	General: WoWWiki					http://www.wowwiki.com/			http://www.wowwiki.com/User:Ketho
	General: Wowhead					http://www.wowhead.com/			http://www.wowhead.com/user=Ketho
	Lua: WowAce							http://www.wowace.com/			http://www.curseforge.com/profiles/Ketho/
	Lua: WoW Programming				http://wowprogramming.com/
	Lua: The Programming Language Lua	http://www.lua.org/
	Lua: lua-users						http://lua-users.org/
	AddOn: Curse						http://www.curse.com/			http://wow.curse.com/members/Ketho.aspx
	AddOn: WoWInterface					http://www.wowinterface.com/	http://www.wowinterface.com/forums/member.php?action=getinfo&userid=230732
	AddOn: WoWUI						http://wowui.incgamers.com/		http://wowui.incgamers.com/?p=profile&u=428922
	Debug: Swatter (from Auctioneer)	http://auctioneeraddon.com/dl/#release
	Debug: DevTools						http://www.wowinterface.com/downloads/info3999-DevTools.html
	Debug: Blizzard_DebugTools /dump	http://www.wowwiki.com/Blizzard_DebugTools
	Extract: Ladik's MPQ Editor			http://zezula.net/en/mpq/download.html
	.BLP: XnView						http://xnview.com/
	.BLP: BLP2PNG						http://www.wowinterface.com/downloads/info6127-BLP2PNG.html
	Windows 7:							http://www.microsoft.com/windows/build/
# ToDo
	A1  Compare leveling speed with guild/server
	A2  Small optional Movable frame with level summary
	01  Instance History + Average Time for in Timer Tab
	PROG1 better string.join()
# Bugs / (to be / not) Fixed Bugs
	BUG2  For some reason the time of RSD is bigger than the actual time / goes way faster; hard to see whats going wrong
	BUG3  Instance Times List realZone not accurate enough for e.g. Scarlet Monastery (no Graveyard / Library in string)
	PROG2  Fix the way the profiles are in the options group, so they wont have "dark background"
	FIXED1  Sometimes a missing level in level summary?! [v0.60]; fixed?
	FIXED2  For some reason when the ding info gets shown just fine the "** |cffBF0D0D[No Levelup Data Found]|r **" The error gets shown as well as the level data [Fixed]
	FIXED3  Bad transition with the levelcounter, missing a level[drycode fixed hopefully] v0.60
	CAVEAT1  Cant filter/block the "/played" message at start of game imho.
	CAVEAT2  Doing alt+tab with auto gratz on, will spam gz for all "queued" dings when its called.
	CAVEAT3  Instance Timer wont be able to see if you re-entered the same instance with dungeon finder. maybe because the "CHAT_MSG_CHANNEL_NOTICE" event doesnt fire again?
	CAVEAT4  The Bnet RealID Broadcast accepts max 127 chars, and SendChatMessage() accepts max 255 chars. Too much variables will go over that max.
# Features/Done
	01  Ding Screenshot; Delayed by AceTimer with AceConfigDialog Range(slider)
	02  Real ID; Restore/broadcast previous Real ID Broadcast message
	03  Show /Played + LevelUp Times Summary in Menu
	04  Instance TimeRun announce (but for Leveling Instances only)
	02  Add more variables for in Ding Message, i.e. Previous Level, Time Difference with last level, average level speed, current level speed
	FEAT1  Localization; Locales
	03  Auto-Gratz to Party/Guild member ding -- no event that fires; use table to see difference?; have to check every x sec (with an event) for a difference in values; registered for "ding" in party/guild messages
# miniFeatures/Done
	01  /Ding Emote
	02  Ding/Achievement Sounds Button + Easter Egg [Fun feature]
	OPTION1  option to disable ding for LV10,20,30,...  (Achievement levels)
	IDEA1  Ding Message Preview Description + Throttle random variables (less annoying)
	IDEA2  Show PlaySoundFile() path Description
	c limit length of message for autogratz to react
	08  instead of random time, the current leveltime for DingMsg variable
	b amount of levels to still go DingMsg variable
	PROG1  Use case sensitive "patterns" better in -> string.upper() + string.sub to find it -> again but then in reverse -> replace with string.gsub now the position is known and its uppercase. kinda troublesome ....
	TEST1  Test if the levelCounter resets at 19 back to 1; Put it at 19 then ding; tested by normal levelups
	06  Use more consistent wording; TimeDing -> LevelTime; TotalTime
	c artwork for in main header
	a time difference last level variable
	01  dutch locale; fail
	02  random gz delay as default option
	b color the example DingMsg variables
	03  random gz messages (x4)
	FEEDBACK1  more feedback for debug mode; needed since addon is getting bigger / more complex
	02  Name, Guild, Location, Max Level in another if-then block
	03  raid target symbols in Ding Msg example
# Removed
	01  Refresh /played when at 95%+ (to fix the time inconsistency); v0.61 accurate now, hopefully
# Code optimalizations
	PROG1  Use local variables(File-local Scope) instead of global variables where possible
	PROG2  Anything inside a function called i.e. "ReadySetDing:" can replace "ReadySetDing." with "self." instead
# Considering / possible/useful/need?
	01  Random Custom Ding messages
	02  Interpolate level ding times
	03  Maybe dont have to request /played if Player is still the same level; need db.char; still need to request for accurate time
	04  To make the Ding Times list, most recent ding always on top when ding, make a1 = a2; a2 = a3; a3 = a4; ...; maybe too hard :S
	05  Announce /played -> rather not. Player can read it from Menu anyway
	FUN1   Take Icons from ...\Interface\GLUES\CHARACTERCREATE\ and use coords from CharacterCreate.lua for some character summary with icons
# Thoughts / Questions / History / Considering
	01  Forget about getglobal(), setglobal() and getfenv(); moreover since the first 2 will be deprecated in cataclysm. Use _G[] instead
	THOUGHT1  Dont really understand "AceTimer:TimeLeft(handle)" want to see how much time there was left on the "RequestTimePlayed()" delay
	HISTORY1  v0.4 didnt have any delay or waited for other leveling AddOns yet; and also no random times that kept changing
	CONSID1  Turn AddOn off, if player can't level anymore(max level according to their "expansionLevel"); actually better not do that, "self.db.profile.enableAddOn" is in the (default) AceDB profile; it would get too troublesome and inconsistent
# Learned Lessons / Minddump
	01  Cant use: array{}, AceDB, GET/SET straight in AceConfigDialog "description". Can use function instead though
	02	For some reason, the game did /played when I changed that specific code in AddOn and then alt-tabbed back into game. huh?!
	03	I put a "counter" in the wrong place. In the options instead of the LevelUp Event Handler/"PLAYER_LEVEL_UP"+"TIME_PLAYED_MSG"
	04	Saving ding level information everytime you ding, 1 by 1 ...
	05	Must find out how to: save a variable that changes if [i] changes or something ... -> Works with for "i = 1,3 do _G["blaat"..i] = i end" but it seems to only work in the LUA live demo ...
	07	Should not replace the short |cff71D5FF with a variable, because of the added "..spc.." the addon will have a minimal size decrease(40bytes~) 1 byte less for each replacement time
--]]